//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

//---------------------------------------------------------------------------
// DICOLIB FUNCTIONS
//---------------------------------------------------------------------------

#include <tigcclib.h>         // Include All Header Files
#include "dicolib.h"

//---------------------------------------------------------------------------

TDico*Dico;
char * lang_str[] = {"English","Francais"};

//---------------------------------------------------------------------------

int DicoLoad(void)
{
	
	char filename[10];
	
	if (Dico->language==TL_ENGLISH)
	strcpy(filename,"motys5e");
	else if (Dico->language==TL_FRENCH)
	strcpy(filename,"motys5f");
	
	
	HSym hsym = SymFind(SYMSTR(filename));
	
	
	if (hsym.folder==0)
	{
		
		clrscr();
		printf("File not found \n '%s'",filename);
		ngetchx();
		
		return 0;
		
	}
	else
	{
		
		Dico->VarPtr = (char *)HeapDeref((DerefSym(hsym))->handle);
		Dico->VarPtr+=2;
		
		sscanf(Dico->VarPtr,"%5d",&Dico->MAXWORDS);
		Dico->VarPtr+=5;
		
		clrscr();
		printf("FileName : %s \n",filename);
		printf("Language : %s \n",lang_str[Dico->language]);
		printf("Words : %d \n ",Dico->MAXWORDS);
		ngetchx();
		
		return 1;
	}
	
}
//---------------------------------------------------------------------------

char* GetWord(int num)
{
	memcpy(Dico->WordStr,Dico->VarPtr+(num<<2)+num,WORD_LENGTH);
	// STRING DELIMITER
	Dico->WordStr[WORD_LENGTH] = 0;
	return Dico->WordStr;
}

//---------------------------------------------------------------------------

int WordExistsL(char * word)
{
	
	int a;
	for (a=0;a<Dico->MAXWORDS;a++)
	{
		int CompareValue=strcmp(word,GetWord(a));
		if (CompareValue==0)
		return 1;
		else if (CompareValue<0)
		return 0;
	}
	
	return 0;
	
}
//---------------------------------------------------------------------------

int WordExists(char * word)
{
	
	
	// FIRST WORD
	if (strcmp(word,GetWord(0))==0)
	return 1;
	
	// LAST WORD
	if (strcmp(word,GetWord(Dico->MAXWORDS-1))==0)
	return 1;
	
	
	
	int IndexMin = 0;
	int IndexMax = Dico->MAXWORDS;
	
	for (;;)
	{
		
		int middle = ((IndexMax+IndexMin)>>1);
		int CompareValue = strcmp(word,GetWord(middle));
		
		if (CompareValue==0)
		return 1;
		else if (CompareValue>0)
		IndexMin = middle;
		else if (CompareValue<0)
		IndexMax = middle;
		
		if ((IndexMax-IndexMin)<=1)
		return 0;
	}
	
	return 0;
}
//---------------------------------------------------------------------------

